diff --git a/source/simulation2/components/CCmpPathfinder_Tile.cpp b/source/simulation2/components/CCmpPathfinder_Tile.cpp
index 21e5463..0402e9a 100644
--- a/source/simulation2/components/CCmpPathfinder_Tile.cpp
+++ b/source/simulation2/components/CCmpPathfinder_Tile.cpp
@@ -1,4 +1,4 @@
-/* Copyright (C) 2010 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -30,15 +30,9 @@
 #include "renderer/TerrainOverlay.h"
 #include "simulation2/helpers/PriorityQueue.h"
 
-typedef PriorityQueueHeap<std::pair<u16, u16>, u32> PriorityQueue;
+#define PATHFIND_STATS 1
 
-#define PATHFIND_STATS 0
-
-#define USE_DIAGONAL_MOVEMENT 1
-
-// Heuristic cost to move between adjacent tiles.
-// This should be similar to DEFAULT_MOVE_COST.
-const u32 g_CostPerTile = 256;
+typedef PriorityQueueHeap<TileID, PathCost> PriorityQueue;
 
 /**
  * Tile data for A* computation.
@@ -63,24 +57,26 @@ public:
 	u16 GetPredI(u16 i) { return (u16)(i + dpi); }
 	u16 GetPredJ(u16 j) { return (u16)(j + dpj); }
 	// Set the pi,pj coords of predecessor, given i,j coords of this tile
-	void SetPred(u16 pi_, u16 pj_, u16 i, u16 j)
+	void SetPred(u16 pi, u16 pj, u16 i, u16 j)
 	{
-		dpi = (i8)((int)pi_ - (int)i);
-		dpj = (i8)((int)pj_ - (int)j);
 #if PATHFIND_DEBUG
 		// predecessor must be adjacent
-		ENSURE(pi_-i == -1 || pi_-i == 0 || pi_-i == 1);
-		ENSURE(pj_-j == -1 || pj_-j == 0 || pj_-j == 1);
+		ENSURE(pi-i == -1 || pi-i == 0 || pi-i == 1);
+		ENSURE(pj-j == -1 || pj-j == 0 || pj-j == 1);
 #endif
+		dpi = (i8)((int)pi - (int)i);
+		dpj = (i8)((int)pj - (int)j);
 	}
 
+	PathCost GetCost() const { return g; }
+	void SetCost(PathCost cost) { g = cost; }
+
 private:
-	u8 status; // this only needs 2 bits
-	i8 dpi, dpj; // these only really need 2 bits in total
-public:
-	u32 cost; // g (cost to this tile)
-	u32 h; // h (heuristic cost to goal) (TODO: is it really better for performance to store this instead of recomputing?)
+	i8 dpi, dpj; // values are in {-1, 0, 1}, pointing to an adjacent tile
+ 	u8 status; // this only needs 2 bits
+	PathCost g; // cost to reach this tile
 
+public:
 #if PATHFIND_DEBUG
 	u32 GetStep() { return step; }
 	void SetStep(u32 s) { step = s; }
@@ -97,52 +93,48 @@ private:
  * Terrain overlay for pathfinder debugging.
  * Renders a representation of the most recent pathfinding operation.
  */
-class PathfinderOverlay : public TerrainOverlay
+class PathfinderOverlay : public TerrainTextureOverlay
 {
-	NONCOPYABLE(PathfinderOverlay);
 public:
 	CCmpPathfinder& m_Pathfinder;
 
-	PathfinderOverlay(CCmpPathfinder& pathfinder)
-		: TerrainOverlay(pathfinder.GetSimContext()), m_Pathfinder(pathfinder)
+	PathfinderOverlay(CCmpPathfinder& pathfinder) :
+		TerrainTextureOverlay(ICmpObstructionManager::NAVCELLS_PER_TILE), m_Pathfinder(pathfinder)
 	{
 	}
 
-	virtual void StartRender()
+	virtual void BuildTextureRGBA(u8* data, size_t w, size_t h)
 	{
 		m_Pathfinder.UpdateGrid();
-	}
-
-	virtual void ProcessTile(ssize_t i, ssize_t j)
-	{
-		if (m_Pathfinder.m_Grid && !IS_PASSABLE(m_Pathfinder.m_Grid->get((int)i, (int)j), m_Pathfinder.m_DebugPassClass))
-			RenderTile(CColor(1, 0, 0, 0.6f), false);
-
-		if (m_Pathfinder.m_DebugGrid)
-		{
-			PathfindTile& n = m_Pathfinder.m_DebugGrid->get((int)i, (int)j);
-
-			float c = clamp((float)n.GetStep() / (float)m_Pathfinder.m_DebugSteps, 0.f, 1.f);
-
-			if (n.IsOpen())
-				RenderTile(CColor(1, 1, c, 0.6f), false);
-			else if (n.IsClosed())
-				RenderTile(CColor(0, 1, c, 0.6f), false);
-		}
-	}
 
-	virtual void EndRender()
-	{
-		if (m_Pathfinder.m_DebugPath)
+		for (size_t j = 0; j < h; ++j)
 		{
-			std::vector<ICmpPathfinder::Waypoint>& wp = m_Pathfinder.m_DebugPath->m_Waypoints;
-			for (size_t n = 0; n < wp.size(); ++n)
+			for (size_t i = 0; i < w; ++i)
 			{
-				u16 i, j;
-				m_Pathfinder.NearestTile(wp[n].x, wp[n].z, i, j);
-				RenderTileOutline(CColor(1, 1, 1, 1), 2, false, i, j);
+				SColor4ub color(0, 0, 0, 0);
+				if (!IS_PASSABLE(m_Pathfinder.m_Grid->get((int)i, (int)j), m_Pathfinder.m_DebugPassClass))
+					color = SColor4ub(255, 0, 0, 127);
+
+				if (m_Pathfinder.m_DebugGrid)
+				{
+					PathfindTile& n = m_Pathfinder.m_DebugGrid->get((int)i, (int)j);
+
+					if (n.IsOpen())
+						color = SColor4ub(255, 255, 0, 127);
+					else if (n.IsClosed())
+						color = SColor4ub(0, 255, 0, 127);
+
+					if (m_Pathfinder.m_DebugGoal.NavcellContainsGoal(i, j))
+						color = SColor4ub(0, 0, 255, 127);
+				}
+
+				*data++ = color.R;
+				*data++ = color.G;
+				*data++ = color.B;
+				*data++ = color.A;
 			}
 		}
+
 	}
 };
 
@@ -164,8 +156,7 @@ void CCmpPathfinder::SetDebugPath(entity_pos_t x0, entity_pos_t z0, const Goal&
 	if (!m_DebugOverlay)
 		return;
 
-	delete m_DebugGrid;
-	m_DebugGrid = NULL;
+	SAFE_DELETE(m_DebugGrid);
 	delete m_DebugPath;
 	m_DebugPath = new Path();
 	ComputePath(x0, z0, goal, passClass, costClass, *m_DebugPath);
@@ -174,16 +165,13 @@ void CCmpPathfinder::SetDebugPath(entity_pos_t x0, entity_pos_t z0, const Goal&
 
 void CCmpPathfinder::ResetDebugPath()
 {
-	delete m_DebugGrid;
-	m_DebugGrid = NULL;
-	delete m_DebugPath;
-	m_DebugPath = NULL;
+	SAFE_DELETE(m_DebugGrid);
+	SAFE_DELETE(m_DebugPath);
 }
 
 
 //////////////////////////////////////////////////////////
 
-
 struct PathfinderState
 {
 	u32 steps; // number of algorithm iterations
@@ -202,7 +190,7 @@ struct PathfinderState
 
 	bool ignoreImpassable; // allows us to escape if stuck in patches of impassability
 
-	u32 hBest; // heuristic of closest discovered tile to goal
+	PathCost hBest; // heuristic of closest discovered tile to goal
 	u16 iBest, jBest; // closest tile
 
 #if PATHFIND_STATS
@@ -215,104 +203,55 @@ struct PathfinderState
 #endif
 };
 
-static bool AtGoal(u16 i, u16 j, const ICmpPathfinder::Goal& goal)
-{
-	// Allow tiles slightly more than sqrt(2) from the actual goal,
-	// i.e. adjacent diagonally to the target tile
-	fixed tolerance = entity_pos_t::FromInt(TERRAIN_TILE_SIZE*3/2);
-
-	entity_pos_t x, z;
-	CCmpPathfinder::TileCenter(i, j, x, z);
-	fixed dist = CCmpPathfinder::DistanceToGoal(CFixedVector2D(x, z), goal);
-	return (dist < tolerance);
-}
-
 // Calculate heuristic cost from tile i,j to destination
 // (This ought to be an underestimate for correctness)
-static u32 CalculateHeuristic(u16 i, u16 j, u16 iGoal, u16 jGoal, u16 rGoal)
+static PathCost CalculateHeuristic(u16 i, u16 j, u16 iGoal, u16 jGoal, u16 rGoal)
 {
-#if USE_DIAGONAL_MOVEMENT
-	CFixedVector2D pos (fixed::FromInt(i), fixed::FromInt(j));
-	CFixedVector2D goal (fixed::FromInt(iGoal), fixed::FromInt(jGoal));
-	fixed dist = (pos - goal).Length();
-	// TODO: the heuristic could match the costs better - it's not really Euclidean movement
-
-	fixed rdist = dist - fixed::FromInt(rGoal);
-	rdist = rdist.Absolute();
-
-	// To avoid overflows on large distances we have to convert to int before multiplying
-	// by the full tile cost, which means we lose some accuracy over short distances,
-	// so do a partial multiplication here.
-	// (This will overflow if sqrt(2)*tilesPerSide*premul >= 32768, so
-	// premul=32 means max tilesPerSide=724)
-	const int premul = 32;
-	cassert(g_CostPerTile % premul == 0);
-	return (rdist * premul).ToInt_RoundToZero() * (g_CostPerTile / premul);
-
-#else
-	return (abs((int)i - (int)iGoal) + abs((int)j - (int)jGoal)) * g_CostPerTile;
-#endif
-}
+//	return (abs((int)i - (int)iGoal) + abs((int)j - (int)jGoal)) * g_CostPerTile;
 
-// Calculate movement cost from predecessor tile pi,pj to tile i,j
-static u32 CalculateCostDelta(u16 pi, u16 pj, u16 i, u16 j, PathfindTileGrid* tempGrid, u32 tileCost)
-{
-	u32 dg = tileCost;
-
-#if USE_DIAGONAL_MOVEMENT
-	// XXX: Probably a terrible hack:
-	// For simplicity, we only consider horizontally/vertically adjacent neighbours, but
-	// units can move along arbitrary lines. That results in ugly square paths, so we want
-	// to prefer diagonal paths.
-	// Instead of solving this nicely, I'll just special-case 45-degree and 30-degree lines
-	// by checking the three predecessor tiles (which'll be in the closed set and therefore
-	// likely to be reasonably stable) and reducing the cost, and use a Euclidean heuristic.
-	// At least this makes paths look a bit nicer for now...
-
-	PathfindTile& p = tempGrid->get(pi, pj);
-	u16 ppi = p.GetPredI(pi);
-	u16 ppj = p.GetPredJ(pj);
-	if (ppi != i && ppj != j)
-		dg = (dg << 16) / 92682; // dg*sqrt(2)/2
-	else
-	{
-		PathfindTile& pp = tempGrid->get(ppi, ppj);
-		int di = abs(i - pp.GetPredI(ppi));
-		int dj = abs(j - pp.GetPredJ(ppj));
-		if ((di == 1 && dj == 2) || (di == 2 && dj == 1))
-			dg = (dg << 16) / 79742; // dg*(sqrt(5)-sqrt(2))
-	}
-#endif
+//	return Cost::horizvert(abs((int)i - (int)iGoal) + abs((int)j - (int)jGoal));
 
-	return dg;
+	int di = abs((int)i - (int)iGoal);
+	int dj = abs((int)j - (int)jGoal);
+	int diag = std::min(di, dj);
+	return PathCost(di-diag + dj-diag, diag);
 }
 
 // Do the A* processing for a neighbour tile i,j.
-static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, u32 pg, PathfinderState& state)
+static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, PathCost pg, PathfinderState& state)
 {
 #if PATHFIND_STATS
 	state.numProcessed++;
 #endif
 
+	PathfindTile& n = state.tiles->get(i, j);
+
+ 	if (n.IsClosed())
+ 		return;
+
 	// Reject impassable tiles
 	TerrainTile tileTag = state.terrain->get(i, j);
 	if (!IS_PASSABLE(tileTag, state.passClass) && !state.ignoreImpassable)
 		return;
 
-	u32 dg = CalculateCostDelta(pi, pj, i, j, state.tiles, state.moveCosts.at(GET_COST_CLASS(tileTag)));
+	PathCost dg;
+	if (pi == i || pj == j)
+		dg = PathCost::horizvert(1);
+	else
+		dg = PathCost::diag(1);
 
-	u32 g = pg + dg; // cost to this tile = cost to predecessor + delta from predecessor
+	PathCost g = pg + dg; // cost to this tile = cost to predecessor + delta from predecessor
 
-	PathfindTile& n = state.tiles->get(i, j);
+	PathCost h = CalculateHeuristic(i, j, state.iGoal, state.jGoal, state.rGoal);
 
 	// If this is a new tile, compute the heuristic distance
 	if (n.IsUnexplored())
 	{
-		n.h = CalculateHeuristic(i, j, state.iGoal, state.jGoal, state.rGoal);
+// 		n.h = CalculateHeuristic(i, j, state.iGoal, state.jGoal, state.rGoal);
 		// Remember the best tile we've seen so far, in case we never actually reach the target
-		if (n.h < state.hBest)
+		if (h < state.hBest)
 		{
-			state.hBest = n.h;
+			state.hBest = h;
 			state.iBest = i;
 			state.jBest = j;
 		}
@@ -321,7 +260,7 @@ static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, u32 pg, PathfinderSta
 	{
 		// If we've already seen this tile, and the new path to this tile does not have a
 		// better cost, then stop now
-		if (g >= n.cost)
+		if (g >= n.GetCost())
 			return;
 
 		// Otherwise, we have a better path.
@@ -330,10 +269,11 @@ static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, u32 pg, PathfinderSta
 		if (n.IsOpen())
 		{
 			// This is a better path, so replace the old one with the new cost/parent
-			n.cost = g;
+			PathCost gprev = n.GetCost();
+			n.SetCost(g);
 			n.SetPred(pi, pj, i, j);
 			n.SetStep(state.steps);
-			state.open.promote(std::make_pair(i, j), g + n.h);
+			state.open.promote(TileID(i, j), gprev + h, g + h);
 #if PATHFIND_STATS
 			state.numImproveOpen++;
 #endif
@@ -341,43 +281,48 @@ static void ProcessNeighbour(u16 pi, u16 pj, u16 i, u16 j, u32 pg, PathfinderSta
 		}
 
 		// If we've already found the 'best' path to this tile:
-		if (n.IsClosed())
-		{
-			// This is a better path (possible when we use inadmissible heuristics), so reopen it
-#if PATHFIND_STATS
-			state.numImproveClosed++;
-#endif
-			// (fall through)
-		}
+// 		if (n.IsClosed())
+// 		{
+// 			// This is a better path (possible when we use inadmissible heuristics), so reopen it
+// #if PATHFIND_STATS
+// 			state.numImproveClosed++;
+// #endif
+// 			// (fall through)
+// 		}
 	}
 
 	// Add it to the open list:
 	n.SetStatusOpen();
-	n.cost = g;
+	n.SetCost(g);
 	n.SetPred(pi, pj, i, j);
 	n.SetStep(state.steps);
-	PriorityQueue::Item t = { std::make_pair(i, j), g + n.h };
+	PriorityQueue::Item t = { TileID(i, j), g + h };
 	state.open.push(t);
 #if PATHFIND_STATS
 	state.numAddToOpen++;
 #endif
 }
 
-void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, Path& path)
+void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& origGoal, pass_class_t passClass, cost_class_t costClass, Path& path)
 {
 	UpdateGrid();
 
 	PROFILE3("ComputePath");
+	double time = timer_Time();
 
 	PathfinderState state = { 0 };
 
 	// Convert the start/end coordinates to tile indexes
 	u16 i0, j0;
-	NearestTile(x0, z0, i0, j0);
-	NearestTile(goal.x, goal.z, state.iGoal, state.jGoal);
+	NearestNavcell(x0, z0, i0, j0);
+
+	Goal goal = origGoal;
+	debug_printf(L"## reachable=%d\n", PathfinderHierMakeGoalReachable(i0, j0, goal, passClass));
+
+	NearestNavcell(goal.x, goal.z, state.iGoal, state.jGoal);
 
 	// If we're already at the goal tile, then move directly to the exact goal coordinates
-	if (AtGoal(i0, j0, goal))
+	if (goal.NavcellContainsGoal(i0, j0))
 	{
 		Waypoint w = { goal.x, goal.z };
 		path.m_Waypoints.push_back(w);
@@ -388,7 +333,7 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 	// a large circle then the heuristics will aim us directly outwards);
 	// otherwise just aim at the center point. (We'll never try moving outwards to a square shape.)
 	if (goal.type == Goal::CIRCLE)
-		state.rGoal = (u16)(goal.hw / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero();
+		state.rGoal = (u16)(goal.hw / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero();
 	else
 		state.rGoal = 0;
 
@@ -397,18 +342,18 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 
 	state.steps = 0;
 
-	state.tiles = new PathfindTileGrid(m_MapSize, m_MapSize);
+	state.tiles = new PathfindTileGrid(m_Grid->m_W, m_Grid->m_H);
 	state.terrain = m_Grid;
 
 	state.iBest = i0;
 	state.jBest = j0;
 	state.hBest = CalculateHeuristic(i0, j0, state.iGoal, state.jGoal, state.rGoal);
 
-	PriorityQueue::Item start = { std::make_pair(i0, j0), 0 };
+	PriorityQueue::Item start = { TileID(i0, j0), PathCost() };
 	state.open.push(start);
 	state.tiles->get(i0, j0).SetStatusOpen();
 	state.tiles->get(i0, j0).SetPred(i0, j0, i0, j0);
-	state.tiles->get(i0, j0).cost = 0;
+	state.tiles->get(i0, j0).SetCost(PathCost());
 
 	// To prevent units getting very stuck, if they start on an impassable tile
 	// surrounded entirely by impassable tiles, we ignore the impassability
@@ -420,8 +365,8 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 
 		// Hack to avoid spending ages computing giant paths, particularly when
 		// the destination is unreachable
-		if (state.steps > 40000)
-			break;
+// 		if (state.steps > 40000)
+// 			break;
 
 		// If we ran out of tiles to examine, give up
 		if (state.open.empty())
@@ -433,16 +378,16 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 
 		// Move best tile from open to closed
 		PriorityQueue::Item curr = state.open.pop();
-		u16 i = curr.id.first;
-		u16 j = curr.id.second;
+		u16 i = curr.id.i();
+		u16 j = curr.id.j();
 		state.tiles->get(i, j).SetStatusClosed();
 
 		// If we've reached the destination, stop
-		if (AtGoal(i, j, goal))
+		if (goal.NavcellContainsGoal(i, j))
 		{
 			state.iBest = i;
 			state.jBest = j;
-			state.hBest = 0;
+			state.hBest = PathCost();
 			break;
 		}
 
@@ -452,23 +397,23 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 		{
 			if (i > 0 && IS_PASSABLE(state.terrain->get(i-1, j), state.passClass))
 				state.ignoreImpassable = false;
-			else if (i < m_MapSize-1 && IS_PASSABLE(state.terrain->get(i+1, j), state.passClass))
+			else if (i < state.terrain->m_W-1 && IS_PASSABLE(state.terrain->get(i+1, j), state.passClass))
 				state.ignoreImpassable = false;
 			else if (j > 0 && IS_PASSABLE(state.terrain->get(i, j-1), state.passClass))
 				state.ignoreImpassable = false;
-			else if (j < m_MapSize-1 && IS_PASSABLE(state.terrain->get(i, j+1), state.passClass))
+			else if (j < state.terrain->m_H-1 && IS_PASSABLE(state.terrain->get(i, j+1), state.passClass))
 				state.ignoreImpassable = false;
 		}
 
-		u32 g = state.tiles->get(i, j).cost;
-		if (i > 0)
-			ProcessNeighbour(i, j, (u16)(i-1), j, g, state);
-		if (i < m_MapSize-1)
-			ProcessNeighbour(i, j, (u16)(i+1), j, g, state);
-		if (j > 0)
-			ProcessNeighbour(i, j, i, (u16)(j-1), g, state);
-		if (j < m_MapSize-1)
-			ProcessNeighbour(i, j, i, (u16)(j+1), g, state);
+		PathCost g = state.tiles->get(i, j).GetCost();
+		ProcessNeighbour(i, j, (u16)(i-1), (u16)(j-1), g, state);
+		ProcessNeighbour(i, j, (u16)(i+1), (u16)(j-1), g, state);
+		ProcessNeighbour(i, j, (u16)(i-1), (u16)(j+1), g, state);
+		ProcessNeighbour(i, j, (u16)(i+1), (u16)(j+1), g, state);
+		ProcessNeighbour(i, j, (u16)(i-1), j, g, state);
+		ProcessNeighbour(i, j, (u16)(i+1), j, g, state);
+		ProcessNeighbour(i, j, i, (u16)(j-1), g, state);
+		ProcessNeighbour(i, j, i, (u16)(j+1), g, state);
 	}
 
 	// Reconstruct the path (in reverse)
@@ -477,7 +422,7 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 	{
 		PathfindTile& n = state.tiles->get(ip, jp);
 		entity_pos_t x, z;
-		TileCenter(ip, jp, x, z);
+		NavcellCenter(ip, jp, x, z);
 		Waypoint w = { x, z };
 		path.m_Waypoints.push_back(w);
 
@@ -487,9 +432,11 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 	}
 
 	// Save this grid for debug display
+	m_DebugTime = timer_Time() - time;
 	delete m_DebugGrid;
 	m_DebugGrid = state.tiles;
 	m_DebugSteps = state.steps;
+	m_DebugGoal = goal;
 
 	PROFILE2_ATTR("from: (%d, %d)", i0, j0);
 	PROFILE2_ATTR("to: (%d, %d)", state.iGoal, state.jGoal);
@@ -497,6 +444,22 @@ void CCmpPathfinder::ComputePath(entity_pos_t x0, entity_pos_t z0, const Goal& g
 	PROFILE2_ATTR("steps: %u", state.steps);
 
 #if PATHFIND_STATS
-	printf("PATHFINDER: steps=%d avgo=%d proc=%d impc=%d impo=%d addo=%d\n", state.steps, state.sumOpenSize/state.steps, state.numProcessed, state.numImproveClosed, state.numImproveOpen, state.numAddToOpen);
+	debug_printf(L"PATHFINDER: steps=%d avgo=%d proc=%d impc=%d impo=%d addo=%d\n", state.steps, state.sumOpenSize/state.steps, state.numProcessed, state.numImproveClosed, state.numImproveOpen, state.numAddToOpen);
 #endif
 }
+
+void CCmpPathfinder::GetDebugData(u32& steps, double& time, Grid<u8>& grid)
+{
+	steps = m_DebugSteps;
+	time = m_DebugTime;
+
+	grid = Grid<u8>(m_DebugGrid->m_W, m_DebugGrid->m_H);
+	for (u16 j = 0; j < grid.m_H; ++j)
+	{
+		for (u16 i = 0; i < grid.m_W; ++i)
+		{
+			PathfindTile t = m_DebugGrid->get(i, j);
+			grid.set(i, j, (t.IsOpen() ? 1 : 0) | (t.IsClosed() ? 2 : 0));
+		}
+	}
+}
